package org.pi3.servlet.samples;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Enumeration;

public class DispatchServlet extends HttpServlet {
  public void doGet( HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException
    {
      response.setContentType("text/html; charset=utf-8");
      StringBuffer sb = new StringBuffer("<H1>Dispatcher Servlet</H1><HR>\r\n");
	sb.append("<p><b>Including Ressource from PathInfo: </b><a href=\"/servlet/DispatchServlet/HelloServlet1\">");
      sb.append("/servlet/DispatchServlet/HelloServlet1</a>\r\n");
	sb.append("<p>(The 'Hello World'-Servlet output will be shown <b>within</b> the output of this Servlet)<hr>");
	sb.append("<p><b>Forwarding to Ressource from PathInfo: </b><a href=\"/servlet/DispatchServlet/HelloServlet2\">");
      sb.append("/servlet/DispatchServlet/HelloServlet2</a>\r\n");
	sb.append("<p>(The 'Hello World'-Servlet output will be shown <b>instead of</b> the output of this Servlet)");
      String s = sb.toString();

      ServletOutputStream out = response.getOutputStream();

	if (request.getPathInfo() != null) {
        if (request.getPathInfo().equalsIgnoreCase("/HelloServlet1")) {

          out.print(s);
          out.print("<p>This text was inserted by the original servlet before the included Servlet.<hr>\r\n");
          getServletContext().getRequestDispatcher("/servlet/org.pi3.servlet.samples.HelloServlet").include(request, response);
          out.print("<p>This text was inserted by the original servlet after the included Servlet.");
          out.print("<p>(Remember, that a Content-Length can't be set here)<hr>\r\n");
        };

        if (request.getPathInfo().equalsIgnoreCase("/HelloServlet2")) {
          getServletContext().getRequestDispatcher("/servlet/org.pi3.servlet.samples.HelloServlet").forward(request, response);
          return;
        };
      } else {
         response.setContentLength(s.length());
         out.print(s);
      };
      out.flush();
    }
  }